//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#include <assert.h>
#pragma hdrstop

//#define DLL_LINK

#include "dllMain.h"


#pragma argsused
//     
LRESULT CALLBACK MouseProc(int code, WPARAM wParam, LPARAM lParam); 
LRESULT CALLBACK KeyProc(int code, WPARAM wParam, LPARAM lParam); 
//LRESULT CALLBACK HookProc(int code, WPARAM wParam, LPARAM lParam); 

//   
HHOOK MHookHandle; 
HHOOK KHookHandle; 
HINSTANCE DllInstance = 0; 
LONG g_mouseLocX = -1;// x-location of mouse position
LONG g_mouseLocY = -1;// y-location of mouse position


int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	DllInstance = hinst; 
	return 1;
}

//--------------------------------------------------------------------------- 
bool InstallHook()
{
	KHookHandle = SetWindowsHookEx(WH_KEYBOARD,(HOOKPROC)KeyProc, DllInstance, 0);
	MHookHandle = SetWindowsHookEx(WH_MOUSE, (HOOKPROC)MouseProc, DllInstance, 0);
	assert(MHookHandle);
	assert(KHookHandle);
	return true;
 } 
//--------------------------------------------------------------------------- 

bool RemoveHook()
{ 
	BOOL bRet1 = UnhookWindowsHookEx(MHookHandle);
	BOOL bRet2 = UnhookWindowsHookEx(KHookHandle);
	assert(bRet1);
	assert(bRet2);
	return (bRet1 && bRet2);
} 

//--------------------------------------------------------------------------- 

DWORD GetLastInput()
{
	return g_dwLastInputTick;
}

//--------------------------------------------------------------------------- 

LRESULT CALLBACK MouseProc(int code, WPARAM wParam, LPARAM lParam) 
{ 
	if(code < 0) return CallNextHookEx(MHookHandle, code, wParam, lParam); 
	if (code==HC_ACTION)
	{
		MOUSEHOOKSTRUCT* pStruct = (MOUSEHOOKSTRUCT*)lParam;
		//we will assume that any mouse msg with the same locations as spurious
		if (pStruct->pt.x != g_mouseLocX || pStruct->pt.y != g_mouseLocY)
		{
			g_mouseLocX = pStruct->pt.x;
			g_mouseLocY = pStruct->pt.y;
			g_dwLastInputTick = GetTickCount();
		}
	}
	return CallNextHookEx(MHookHandle, code, wParam, lParam); 
}

//--------------------------------------------------------------------------- 

LRESULT CALLBACK KeyProc(int code, WPARAM wParam, LPARAM lParam) 
{ 
	if(code < 0) return CallNextHookEx(KHookHandle, code, wParam, lParam); 
	if (code==HC_ACTION)
	{
		g_dwLastInputTick = GetTickCount();
	}
	return CallNextHookEx(KHookHandle, code, wParam, lParam); 
}

//---------------------------------------------------------------------------
